Supermin appliance.
[febootstrap.git] / febootstrap-supermin-helper.sh
1 #!/bin/bash -
2 # febootstrap-supermin-helper
3 # (C) Copyright 2009 Red Hat Inc.
4 #
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
18 #
19 # Written by Richard W.M. Jones <rjones@redhat.com>
20
21 unset CDPATH
22
23 TEMP=`getopt \
24         -o '' \
25         --long help,kmods: \
26         -n febootstrap-supermin-helper -- "$@"`
27 if [ $? != 0 ]; then
28     echo "febootstrap-supermin-helper: problem parsing the command line arguments"
29     exit 1
30 fi
31 eval set -- "$TEMP"
32
33 usage ()
34 {
35     echo "Usage: febootstrap-supermin-helper supermin.img hostfiles.txt kernel initrd"
36     echo "Please read febootstrap-supermin-helper(8) man page for more information."
37 }
38
39 kmods=""
40
41 while true; do
42     case "$1" in
43         --help)
44             usage
45             exit 0;;
46         --kmods)
47             kmods=$2
48             shift 2;;
49         --)
50             shift
51             break;;
52         *)
53             echo "Internal error!"
54             exit 1;;
55     esac
56 done
57
58 if [ $# -ne 4 ]; then
59     usage
60     exit 1
61 fi
62
63 set -e
64
65 # Input files.
66 supermin="$1"
67 hostfiles="$2"
68
69 # Output files.
70 kernel="$3"
71 initrd="$4"
72
73 rm -f "$kernel" "$initrd"
74
75 # Kernel:
76 # Look for the most recent kernel named vmlinuz-*.<arch>* which has a
77 # corresponding directory in /lib/modules/. If the architecture is x86, look
78 # for any x86 kernel.
79 #
80 # RHEL 5 didn't append the arch to the kernel name, so look for kernels
81 # without arch second.
82
83 arch=$(echo "@host_cpu@" | sed 's/^i.86$/i?86/')
84 kernels=$(ls -1vr /boot/vmlinuz-*.$arch* 2>/dev/null | grep -v xen; ls -1vr /boot/vmlinuz-* 2>/dev/null | grep -v xen)
85 for f in $kernels; do
86     b=$(basename "$f")
87     b=$(echo "$b" | sed 's,vmlinuz-,,')
88     modpath="/lib/modules/$b"
89     if [ -d "$modpath" ]; then
90         ln -sf "$f" "$kernel"
91         break
92     fi
93     modpath=
94 done
95
96 if [ -z "$modpath" ]; then
97     echo "$0: failed to find a suitable kernel" >&2
98     exit 1
99 fi
100
101 # The initrd consists of these components:
102 # (1) The base skeleton appliance that we constructed at build time.
103 #     format = plain cpio (could be compressed cpio)
104 # (2) The modules from modpath which are on the module whitelist.
105 #     format = plain cpio
106 # (3) The host files which match wildcards in hostfiles.
107 #     format = plain cpio
108
109 cp "$supermin" "$initrd" ;# (1)
110
111 # Kernel modules (2).
112
113 if [ -n "$kmods" ]; then
114     exec 5<"$kmods"
115     whitelist=
116     while read kmod 0<&5; do
117         whitelist="$whitelist -o -name $kmod"
118     done
119     exec 5<&-
120 else
121     whitelist="-o -name *.ko"
122 fi
123
124 find "$modpath" \( -not -name '*.ko' $whitelist \) -a -print0 |
125   cpio --quiet -o -0 -H newc >> "$initrd"
126
127 # Host files (3).
128
129 hostfiles=$(readlink -f "$hostfiles")
130 (cd / &&
131     ls -1df $(cat "$hostfiles") 2>/dev/null |
132     cpio --quiet -o -H newc ) >> "$initrd"